<template>
    <div class="DrainageAcid">
        <h2 style="margin-bottom: 20px;padding-bottom:7px;border-bottom:2px solid #ddd">排酸损耗</h2>
        <header id="header">
            <el-row type="flex" :gutter="20">
                <el-col :span="4">
                    <el-input v-model="search" placeholder="请选择"></el-input>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="getDrainageAcidList">查找</el-button>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="add">新增</el-button>
                </el-col>
            </el-row>
        </header>
        <section>
            <article class="table">
                <el-table
                    ref="multipleTable"
                    :data="tableData"
                    tooltip-effect="dark"
                    style="width: 100%"
                >
                    <el-table-column prop="id" label="序号" width="80"></el-table-column>
                    <el-table-column prop="slaughterBatch" label="屠宰批次" width="180"></el-table-column>
                    <el-table-column prop="productName" label="产品名称" width="180"></el-table-column>
                    <el-table-column prop="acidTime" label="排酸时间"></el-table-column>
                    <el-table-column prop="weightBefore" label="排酸前重量(kg)" width="180"></el-table-column>
                    <el-table-column prop="weightAfter" label="排酸后重量(kg)" width="180"></el-table-column>
                    <el-table-column prop="acidLoss" label="排酸损耗(kg)" width="180"></el-table-column>
                    <el-table-column prop="responsiblePerson" label="负责人员"></el-table-column>
                    <el-table-column label="操作" width="150">
                        <template slot-scope="scope">
                            <el-button @click="edit(scope.row)" type="text" size="small">编辑</el-button>
                            <el-popconfirm title="是否删除此设备的信息？" @onConfirm="del(scope.row)">
                                <el-button slot="reference" type="text" size="small">删除</el-button>
                            </el-popconfirm>
                        </template>
                    </el-table-column>
                </el-table>

                <el-row type="flex" justify="end">
                    <el-col :span="8" class="pagination">
                        <el-pagination
                            @current-change="pageChange"
                            background
                            layout="prev, pager, next"
                            :page-count="Number(totalPages)"
                        ></el-pagination>
                    </el-col>
                </el-row>
            </article>
        </section>

        <el-dialog title="新增/编辑" :visible.sync="isShow" width="40%">
            <el-row type="flex">
                <el-col :span="20">
                    <el-form
                        ref="addDrainageAcid"
                        :model="formData"
                        :rules="rules"
                        label-width="140px"
                    >
                        <el-form-item label="屠宰批次">
                            <el-input v-model="formData.slaughterBatch"></el-input>
                        </el-form-item>

                        <el-form-item label="产品名称">
                            <el-input v-model="formData.productName"></el-input>
                        </el-form-item>

                        <el-form-item label="排酸时间">
                            <el-date-picker
                                v-model="formData.acidTime"
                                type="date"
                                value-format="yyyy-MM-dd"
                                placeholder="选择日期"
                            ></el-date-picker>
                        </el-form-item>

                        <el-form-item label="排酸前重量(kg)">
                            <el-input v-model="formData.weightBefore"></el-input>
                        </el-form-item>

                        <el-form-item label="排酸后重量(kg)">
                            <el-input v-model="formData.weightAfter"></el-input>
                        </el-form-item>

                        <el-form-item label="排酸损耗(kg)">
                            <el-input v-model="formData.acidLoss"></el-input>
                        </el-form-item>

                        <el-form-item label="负责人员">
                            <el-input v-model="formData.responsiblePerson"></el-input>
                        </el-form-item>

                        <el-form-item>
                            <el-button @click="isShow=false">取 消</el-button>
                            <el-button type="primary" @click="submitForm('addDrainageAcid')">保 存</el-button>
                        </el-form-item>
                    </el-form>
                </el-col>
            </el-row>
        </el-dialog>
    </div>
</template>

<script>
import {
    reqDrainageAcidList,
    reqAddDrainageAcid,
    reqUpdateDrainageAcid,
    reqDelDrainageAcid
} from "@/api/slaughterManagment.js";

const pageSize = 10;
const rules = {};

export default {
    name: "DrainageAcid",
    data() {
        return {
            search: "",
            page: 1,
            tableData: [],
            totalPages: 0,
            isShow: false,
            formData: {
                slaughterBatch: "1960",
                productName: "1960",
                acidTime: this.$moment().format("YYYY-MM-DD"),
                weightBefore: "32",
                weightAfter: "30",
                acidLoss: "2",
                responsiblePerson: "王三喜"
            },
            isAdd: false,
            rules
        };
    },
    created() {
        // 排酸损耗列表
        this.getDrainageAcidList();
    },
    watch: {
        "formData.weightBefore"(v, ov) {
            if (Number(v).toString() == "NaN") {
                this.$message.error("请输入数字");
                return;
            }
            this.formData.acidLoss = v - this.formData.weightAfter;
        },
        "formData.weightAfter"(v, ov) {
            if (Number(v).toString() == "NaN") {
                this.$message.error("请输入数字");
                return;
            }
            this.formData.acidLoss = this.formData.weightBefore - v;
        }
    },
    methods: {
        submitForm(formName) {
            this.$refs[formName].validate(valid => {
                if (valid) {
                    if (this.isAdd) {
                        reqAddDrainageAcid(this.formData)
                            .then(res => {
                                // 排酸损耗列表
                                this.getDrainageAcidList();
                                this.$message.success("添加成功！");
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("添加失败！");
                            });
                    } else {
                        reqUpdateDrainageAcid(this.formData)
                            .then(res => {
                                // 排酸损耗列表
                                this.getDrainageAcidList();
                                this.$message.success("编辑成功！");
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("编辑失败！");
                            });
                    }
                } else {
                    return false;
                }
            });
        },
        // 排酸损耗列表
        getDrainageAcidList() {
            reqDrainageAcidList({
                searchStr: this.search,
                pageSize,
                pageNum: this.page
            })
                .then(res => {
                    this.tableData = res.content;
                    this.totalPages = res.totalPages;
                })
                .catch(err => {
                    console.log(err);
                });
        },
        add() {
            this.isShow = true;
            this.isAdd = true;
        },
        edit(row) {
            this.formData = row;
            this.isShow = true;
            this.isAdd = false;
        },
        del(row) {
            reqDelDrainageAcid(row.id)
                .then(res => {
                    console.log(res);
                    // 排酸损耗列表
                    this.getDrainageAcidList();
                    this.$message.success("删除成功！");
                })
                .catch(err => {
                    console.log(err);
                    this.$message.error("删除失败！");
                });
        },
        pageChange(p) {
            console.log(p);
            this.page = p;
            // 排酸损耗列表
            this.getDrainageAcidList();
        }
    }
};
</script>

<style lang="scss" scoped>
#header {
    margin-bottom: 15px;
}
.table {
    .pagination {
        margin-top: 20px;
    }
}
</style>